

CREATE OR REPLACE FUNCTION spCAdj_Void(
	_CAdjNo		VARCHAR(15),
	_DoDelete	BOOLEAN
) RETURNS SETOF SPStatus AS 
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_spretstockad_void	SPStatus%ROWTYPE;
	_CashID			VARCHAR(15);
	_CAdjDate		DATE;
	_LockDate		DATE;
	_isDraft		BOOLEAN;
BEGIN
	_retval:=(50001, 'GENERAL ERROR (spCashA_Void)');

	SELECT INTO _CashID, _CAdjDate, _isDraft cashID, CAdjDate, isDraft FROM CAdj WHERE CAdjNo=_CAdjNo;

	IF NOT FOUND THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg:='CAdjNo ' || _CAdjNo || ' not found (spCAdj_Void)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_isDraft IS NOT NULL AND _isDraft=TRUE) THEN
		IF (_DoDelete=TRUE) THEN
			DELETE FROM CAdj where CAdjNo=_CAdjNo;
		END IF;

		_retval:=(0, 'OK');
		RETURN NEXT _retval;
		RETURN;
	END IF;

	SELECT INTO _LockDate lockdate FROM TLock WHERE TransType='CADJ';
	IF(_LockDate is not null AND _LockDate>_CAdjDate) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Penyesuaian Kas Melebihi Batas Tanggal Kunci Transaksi !';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _spret * FROM spCashA_Void_byRef('CADJ', _CAdjNo, _CashID, null);
	IF _spret.ErrNo	<>0 THEN
		_retval.ErrNo:=_spret.ErrNo;
		_retval.ErrMsg:=_spret.ErrMsg;
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF isAccInstalled() THEN
		SELECT into _spretstockad_void * from spJnl_Void_byRef('CADJ',_CAdjNo);
		IF _spretstockad_void.ErrNo<>0 THEN
			_retval.ErrNo:=_spretstockad_void.ErrNo;
			_retval.ErrMsg:=_spretstockad_void.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
	/*--		EXIT;*/
		END IF;
	END IF;

	IF (_DoDelete=TRUE) THEN
		DELETE FROM CAdj where CAdjNo=_CAdjNo;
	END IF;

	_retval:=(0, 'OK');
	RETURN NEXT _retval;
END;
$BODY$ 
LANGUAGE 'plpgsql' VOLATILE;


CREATE OR REPLACE FUNCTION spCAdj_Void(
	_CAdjNo		VARCHAR(15)
) RETURNS SETOF SPStatus AS 
$BODY$
DECLARE
	_retval		SPStatus%ROWTYPE;
	_spret		SPStatus%ROWTYPE;

BEGIN
	_retval:=(0, 'OK');

	SELECT INTO _spret * FROM spCAdj_Void(_CAdjNo, TRUE);
	IF (_spret.ErrNo<>0) THEN
		_retval.ErrNo:=_spret.ErrNo;
		_retval.ErrMsg:=_spret.ErrMsg;
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	RETURN NEXT _retval;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;



CREATE OR REPLACE FUNCTION spFixCAdj_Wetan()
RETURNS SETOF SPStatus AS
$BODY$
DECLARE
	_retval		SPStatus%ROWTYPE;
	_spret		SPStatus%ROWTYPE;

	cData		REFCURSOR;

	_CAdjNo		cadj.cadjno%TYPE;
	_LockDate	DATE;
BEGIN
	_retval:=(0, 'OK');

	SELECT INTO _LockDate lockdate FROM tlock LIMIT 1;
	UPDATE tlock SET lockdate=NULL;

	OPEN cData FOR
		SELECT cadjno FROM cadj WHERE cashid='CASH01' AND (crcid IS NULL OR excrate=0);
	LOOP
		FETCH cData INTO _CAdjNo;
		EXIT WHEN NOT FOUND;

		SELECT INTO _spret * FROM spCAdj_Void(_CAdjNo, FALSE);
		IF (_spret.ErrNo<>0) THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		UPDATE cadj SET crcid='IDR', excrate=1, fisrate=1 WHERE cadjno=_CAdjNo;

		SELECT INTO _spret * FROM spCAdj_New(_CAdjNo);
		IF (_spret.ErrNo<>0) THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END LOOP;
	CLOSE cData;

	UPDATE tlock SET lockdate=_LockDate;

	RETURN NEXT _retval;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;


SELECT * FROM spFixCAdj_Wetan();


